/* Funktion ft das About-Fenster
   Versionsstring des gesamten KonnMucks

										Datei: about.c
										Datum: 07.12.1996
										Rev. : 26.01.1997
										Rev.2: 30.04.2000
										Autor: KS
										
                            AppBuilder Photon Code Lib
                                         Version 1.11

*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "header.h"
#include "abimport.h"
#include "proto.h"

char rcs_id[] = "$Id: about.c,v 0.90 2000/04/30 12:36:54 klaus Exp klaus $";

int about_setup(PtWidget_t *link_instance,ApInfo_t *apinfo,PtCallbackInfo_t *cbinfo)
{
	PtArg_t args[1];
	char *zeig;

	/* Prefix holen */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&zeig,0);
	PtGetResources(ABW_version,1,args);
	get_version(buf,zeig);
	/* Neuen String setzen */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,buf,0);
	PtSetResources(ABW_version,1,args);

	return Pt_CONTINUE;
}

/* Kopiert die Versionsnummer mit dem Prefix 'prefix' in den Puffer 'buffer' */
void get_version(char *buffer,char *prefix)
{
	char *version = rcs_id;
	char *zeig;
	int ind;

	/* Zur Versionsnummer in der RCS-ID gehen */
	for (ind=0;ind<2;ind++) {
		version++;
		for (;*version != ' ' && *version != '\0';version++);
	}
	version++; /* Leerzeichen berlesen */

	/* Prefix in buf kopieren */
	zeig = buffer;
	if (prefix) {
		strcpy(buffer,prefix);
		/* Ans Ende des Strings gehen */
		for (;*zeig != '\0';zeig++);
	}
	/* Versionsnummer kopieren */
	for (;*version != ' ' && *version != '\0';version++,zeig++) {
		*zeig = *version;
	}
	/* Mit '\0' abschlieen */
	*zeig = '\0';

	/* Das war's */
	return;
}
