/* Beenden des KonnMuck-Programms

									Datei: quit.c
									Datum: 01.09.1996
									Rev. : 11.12.1996
									Autor: KS

rcs_id: $Id: quit.c,v 4.0 1997/01/04 12:25:19 klaus Exp klaus $

                            AppBuilder Photon Code Lib
                                         Version 1.11B
*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>     /* free(), exit() */
#include <sys/socket.h> /* shutdown() */

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "config.h"
#include "header.h"
#include "abimport.h"
#include "proto.h"

int quit( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{

	if (verbindung.sock >= 0) {
		/* Verbindung besteht, runterfahren */
		shutdown(verbindung.sock,2);
		verbindung.sock = -1;

		/* Logdatei schlieen */		
		if (verbindung.fpLog) {
			fclose(verbindung.fpLog);
			verbindung.fpLog = NULL;
		}
		
		/* Alle weiteren Prozesse beenden */
		prozesse_runterfahren();
	}

	/* Speicherplatz freigeben */
	ApCloseDBase(textdb); /* Meldungen fr die Mehrsprachen-Untersttzung */
	FREEMUCKLIST(mucks); /* Speicherplatz der Muckliste freigeben */
	free(konfigdaten.cfgdateiname);
	free(prozessdaten.connect_pfad);
	free(prozessdaten.empfangs_pfad);
	free(buf); /* Puffer freigeben */
	
	/* Programm beenden */
	exit(0);
}
