#ifndef lint
char yysccsid[] = "@(#)yaccpar	1.4 (Berkeley) 02/25/90";
#endif
/* Konfigurationsdateiinterpreter mit lex und yacc
   Parser

											Datei: cfgdatei.y
											Datum: 26.11.1995
											Rev. : 01.10.1996
											Autor: KS
*/

#include <stdio.h>

#if ((!defined _INCLUDE_LEX_YACC_) && (!defined __CFGDATEI_H_INCLUDED__))
 /* Extradefinitionen, wenn jedes Modul einzeln bersetzt wird */
#include "cfgdatei.h"
#endif

/* Rckgabewerte von keyword() und abschnitte() im Falle eines Fehlers */
#define NICHT_GEFUNDEN -1
#define DONT_CARE      -2
#define FEHLER         -3

/* Globale Variablen */
INHALT *yyinhalt; /* Inhalt */
int yyzeile;      /* Zeilennummer */
char *yycfgdatei; /* Konfigurationsdateiname */
int yyabschnitt = NICHT_GEFUNDEN; /* Aktueller Abschnitt */
typedef union {
	long val;
	char *string;
} YYSTYPE;
#define STRING 257
#define STRING_PTR 258
#define NUMBER 259
#define INT_PTR 260
#define LONG_PTR 261
#define BEZEICHNER 262
#define BEZEICHNER_PTR 263
#define DEF_BEZEICHNER 264
#define ABSCHNITT 265
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    1,    1,    1,    1,
};
short yylen[] = {                                         2,
    0,    1,    2,    4,    4,    4,    1,
};
short yydefred[] = {                                      0,
    0,    7,    0,    2,    0,    3,    0,    0,    0,    4,
    5,    6,
};
short yydgoto[] = {                                       3,
    4,
};
short yysindex[] = {                                   -261,
  -58,    0, -261,    0, -257,    0,  -53,  -52,  -51,    0,
    0,    0,
};
short yyrindex[] = {                                      9,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,
};
short yygindex[] = {                                      0,
    7,
};
#define YYTABLESIZE 10
short yytable[] = {                                       7,
    1,    8,    5,    2,    9,   10,   11,   12,    1,    6,
};
short yycheck[] = {                                     257,
  262,  259,   61,  265,  262,   59,   59,   59,    0,    3,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 265
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,"'='",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"STRING","STRING_PTR",
"NUMBER","INT_PTR","LONG_PTR","BEZEICHNER","BEZEICHNER_PTR","DEF_BEZEICHNER",
"ABSCHNITT",
};
char *yyrule[] = {
"$accept : statement_list",
"statement_list :",
"statement_list : statement",
"statement_list : statement_list statement",
"statement : BEZEICHNER '=' STRING ';'",
"statement : BEZEICHNER '=' NUMBER ';'",
"statement : BEZEICHNER '=' BEZEICHNER ';'",
"statement : ABSCHNITT",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifndef YYSTACKSIZE
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 300
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
#define yystacksize YYSTACKSIZE
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
int keyword(char *word,int *stelle_ind)
{
	INHALT *ptr = yyinhalt;

	if (yyabschnitt < 0) /* Falscher Abschnitt */
		return yyabschnitt;

	for ((*stelle_ind)=0;ptr[yyabschnitt].eintraege[(*stelle_ind)].bezeichner != NULL;(*stelle_ind)++) { /* Alle Eintrge eines Abschnitts durchlaufen */
		if (!stringcompare(ptr[yyabschnitt].eintraege[(*stelle_ind)].bezeichner,word)) { /* Richtiger Eintrag ? */
			/* Ja, Treffer ! */
			return ptr[yyabschnitt].eintraege[(*stelle_ind)].typ;
		}
	}
	/* Nicht gefunden */
	return (ptr[yyabschnitt].optionen & MEHR) ? DONT_CARE : NICHT_GEFUNDEN;
}

int abschnitte(char *word)
{
	INHALT *ptr = yyinhalt;
	int ind,
	    len = strlen(word)-2;

	for(ind=0;ptr[ind].eintraege != NULL;ind++) {
		if (!strncmp(ptr[ind].abschnitt.abschnitt,(word+1),len)) {
			return ind;
		}
	}
	/* Nicht gefunden */
	return (ptr[ind].optionen & MEHR) ? DONT_CARE : NICHT_GEFUNDEN;
}

int bezeichner_def(BEZEICHNER_DEF *def,char *word,int *wert)
{
	int ind;

	if (!def)
		return NICHT_GEFUNDEN; /* Null-Zeiger */

	for (ind=0;def[ind].bezeichner;ind++) {
		if (!stringcompare(def[ind].bezeichner,word)) {
			*wert = def[ind].wert;
			return ind;
		}
	}
	return NICHT_GEFUNDEN;
}

int stringcompare(char *string1, char *string2)
{
	if (yyinhalt[yyabschnitt].optionen & GROSSKLEINEGAL)
		return stricmp(string1,string2);
	else
		return strcmp(string1,string2);
}
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 4:
{
			int stelle;

			switch(keyword(yyvsp[-3].string ,&stelle)) { /* Welcher Typ? */
				case EGAL: /* Typ egal */
				case STRING:
					yyinhalt[yyabschnitt].eintraege[stelle].werte.string = yyvsp[-1].string ;
					yyinhalt[yyabschnitt].eintraege[stelle].typ = STRING;
					break;
				case STRING_PTR:
					*(yyinhalt[yyabschnitt].eintraege[stelle].werte.string_ptr) = yyvsp[-1].string ;
					yyinhalt[yyabschnitt].eintraege[stelle].typ = STRING_PTR;
					break;
				case NICHT_GEFUNDEN:
					yyexterror(F_BEZEICHNER,yyvsp[-3].string );
					free(yyvsp[-1].string ); /* Wert wird nicht mehr benutzt */
					break;
				case DONT_CARE:
					free(yyvsp[-1].string ); /* Wert wird nicht mehr benutzt */
					break; /* Nichts */
				default: /* Falscher Typ */
					yyexterror(F_TYP,yyvsp[-3].string );
					free(yyvsp[-1].string ); /* Wert wird nicht mehr benutzt */
					break;
			}
			free(yyvsp[-3].string ); /* Bezeichner wird nicht mehr gebraucht */
		}
break;
case 5:
{
			int stelle;

			switch (keyword(yyvsp[-3].string ,&stelle)) {
				case EGAL: /* Typ egal */
				case NUMBER:
					yyinhalt[yyabschnitt].eintraege[stelle].werte.val = (long)yyvsp[-1].val ;
					yyinhalt[yyabschnitt].eintraege[stelle].typ = NUMBER;
					break;
				case INT_PTR:
					*(yyinhalt[yyabschnitt].eintraege[stelle].werte.int_ptr) = (int)yyvsp[-1].val ;
					yyinhalt[yyabschnitt].eintraege[stelle].typ = INT_PTR;
					break;
				case LONG_PTR:
					*(yyinhalt[yyabschnitt].eintraege[stelle].werte.long_ptr) = (long)yyvsp[-1].val ;
					yyinhalt[yyabschnitt].eintraege[stelle].typ = LONG_PTR;
					break;
				case NICHT_GEFUNDEN:
					yyexterror(F_BEZEICHNER,yyvsp[-3].string );
					break;
				case DONT_CARE:
					break; /* Nichts */
				default:
					yyexterror(F_TYP,yyvsp[-3].string );
					break;
			}
			free(yyvsp[-3].string ); /* Bezeichner wird nicht mehr gebraucht */
		}
break;
case 6:
{
			int stelle,zw;

			switch(keyword(yyvsp[-3].string ,&stelle)) {
				case EGAL: /* Typ egal */
				case BEZEICHNER:
					yyinhalt[yyabschnitt].eintraege[stelle].werte.string = yyvsp[-1].string ;
					yyinhalt[yyabschnitt].eintraege[stelle].typ = BEZEICHNER;
					break;
				case BEZEICHNER_PTR:
					*(yyinhalt[yyabschnitt].eintraege[stelle].werte.string_ptr) = yyvsp[-1].string ;
					yyinhalt[yyabschnitt].eintraege[stelle].typ = BEZEICHNER_PTR;
					break;
				case DEF_BEZEICHNER:
					if (bezeichner_def(yyinhalt[yyabschnitt].eintraege[stelle].def,yyvsp[-1].string ,&zw) != NICHT_GEFUNDEN) {
						yyinhalt[yyabschnitt].eintraege[stelle].werte.val = zw;
						yyinhalt[yyabschnitt].eintraege[stelle].typ = DEF_BEZEICHNER;
					}
					else {
						yyexterror(F_BEZ_WERT,yyvsp[-1].string );
					}
					free(yyvsp[-1].string );
					break;
				case NICHT_GEFUNDEN:
					yyexterror(F_BEZEICHNER,yyvsp[-3].string );
					free(yyvsp[-1].string ); /* Wert wird nicht mehr benutzt */
					break;
				case DONT_CARE:
					free(yyvsp[-1].string ); /* Wert wird nicht mehr benutzt */
					break; /* Nichts */
				default:
					yyexterror(F_TYP,yyvsp[-3].string );
					free(yyvsp[-1].string ); /* Wert wird nicht mehr benutzt */
					break;
			}
			free(yyvsp[-3].string ); /* Bezeichner wird nicht mehr gebraucht */
		}
break;
case 7:
{
			int zw;
			INHALT *inhptr = yyinhalt;

			switch(zw = abschnitte(yyvsp[0].string )) {
				case NICHT_GEFUNDEN:
					yyexterror(F_ABSCHNITT,yyvsp[0].string );
					break;
				default: /* Gut gegangen */
					yyabschnitt = zw;
					break;
			}

			for(;inhptr->eintraege != NULL;inhptr++); /* Ans Ende der Inhaltsstruktur gehen */
			if (inhptr->optionen & ABSCHNITTE) {
				/* Man will eine Liste aller Abschnitte haben */
				ALLE_ABSCHNITTE *abptr,*abptr_vor = NULL;
				int len = strlen(yyvsp[0].string )-2; /* Lnge des Abschnittstrings */

				abptr = inhptr->abschnitt.alle_abschnitte; /* Hier werden alle Abschnittsnamen gespeichert */
				for(;abptr;abptr_vor = abptr,abptr = abptr->next); /* Ans Ende gehen */

				#ifdef __EIN_FELD__
				if ((abptr = (ALLE_ABSCHNITTE *)malloc(sizeof(ALLE_ABSCHNITTE)+len+1)) == NULL) {
				#else
				if (((abptr = (ALLE_ABSCHNITTE *)malloc(sizeof(ALLE_ABSCHNITTE))) == NULL) || ((abptr->abschnitt = (unsigned char *)malloc(len+1)) == NULL)) {
				#endif

					yyerror(F_SPEICHER);
					return 1; /* Abort */

				#ifdef __EIN_FELD__
				}
				abptr->abschnitt = (char *)(abptr+1);
				#else
				}
				#endif

				abptr->next = NULL;
				strncpy(abptr->abschnitt,yyvsp[0].string +1,len);
				*(abptr->abschnitt+len) = '\0';
				if (!abptr_vor) /* Der allererste Eintrag */
					inhptr->abschnitt.alle_abschnitte = abptr;
				else /* Alle weiteren Eintrge */
					abptr_vor->next = abptr;
			}
		}
break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#ifdef YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#ifdef YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
