/* Eingabe der Portnummern: Nur Ziffern erlaubt

									Datei: porteing.c
									Datum: 18.10.1996
									Rev. : 18.10.1996
									Autor: KS

                            AppBuilder Photon Code Lib
                                         Version 1.11B
*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "header.h"
#include "abimport.h"
#include "proto.h"

int porteing( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	int len,ind;
	PtTextCallback_t *cbs = (PtTextCallback_t *)cbinfo->cbdata;

	if (cbs->text == NULL)
		return Pt_CONTINUE;

	for(len = 0;len < cbs->length;len++) {
		if ((cbs->text[len] < '0') || (cbs->text[len] > '9')) { /* Keine Zahl */
			/* Nicht annehmen: Alles folgende nach vorne verschieben */
			for(ind=len;ind < cbs->length;ind++) {
				cbs->text[ind] = cbs->text[ind+1];
			}
			cbs->length--;
		}
	}

	return Pt_CONTINUE;
}
